#include "KeyboardSynthesizer.hpp"
#include "KeyBind.hpp"
#include "CritialSectionLock.hpp"

KeyboardSynthesizer::KeyboardSynthesizer(const KeyBind* keyBind)
: keyBind_(keyBind)
{
	// 擾(0xffff)ŏ
	memset(scanCodes_, 0xff, sizeof(scanCodes_));

	// L[{[hpf[^
	ZeroMemory(&keyboard_, sizeof(INPUT));
	keyboard_.type = INPUT_KEYBOARD;

	InitializeCriticalSection(&criticalSection_);
}


KeyboardSynthesizer::~KeyboardSynthesizer()
{
	DeleteCriticalSection(&criticalSection_);
}

void KeyboardSynthesizer::press(BYTE noteNumber)
{
	CritialSectionLock lock(&criticalSection_);

	WORD key = keyBind_->getNoteNumber(noteNumber);

	if ((key & KeyBind::ModifierKey::SHIFT) != 0)
		keyDown(VK_SHIFT);

	if ((key & KeyBind::ModifierKey::CONTROL) != 0)
		keyDown(VK_CONTROL);

	if ((key & KeyBind::ModifierKey::ALTERNATE) != 0)
		keyDown(VK_MENU);

	keyDown(static_cast<BYTE>(key));

	// ʂ̃L[͑fdown upĂ肱ڂȂ̂
	// CL[͉̂肱ڂ̂ŏCL[gꍇ͏X[v
	if ((key & 0xff00) != 0)
		Sleep(25);
	keyUp(static_cast<BYTE>(key));

	if ((key & KeyBind::ModifierKey::ALTERNATE) != 0)
		keyUp(VK_MENU);

	if ((key & KeyBind::ModifierKey::CONTROL) != 0)
		keyUp(VK_CONTROL);

	if ((key & KeyBind::ModifierKey::SHIFT) != 0)
		keyUp(VK_SHIFT);
	Sleep(25);
}

void KeyboardSynthesizer::release(BYTE noteNumber)
{
	// pressɎrelease铮̂߂ł͉Ȃ
}

void KeyboardSynthesizer::reset()
{
	// pressɎrelease铮̂߂ł͉Ȃ
}

void KeyboardSynthesizer::keyDown(BYTE virtualKey)
{
	WORD scanCode = getScanCode(virtualKey);
	if (scanCode == 0)
		return;

	keyboard_.ki.wScan = scanCode & 0x00ff;

	keyboard_.ki.dwFlags = KEYEVENTF_SCANCODE;
	if ((scanCode & 0xff00) == 0xe000)
		keyboard_.ki.dwFlags |= KEYEVENTF_EXTENDEDKEY;

	SendInput(1, &keyboard_, sizeof(INPUT));
}

void KeyboardSynthesizer::keyUp(BYTE virtualKey)
{
	WORD scanCode = getScanCode(virtualKey);
	if (scanCode == 0)
		return;

	keyboard_.ki.wScan = scanCode & 0x00ff;

	keyboard_.ki.dwFlags = KEYEVENTF_SCANCODE | KEYEVENTF_KEYUP;
	if ((scanCode & 0xff00) == 0xe000)
		keyboard_.ki.dwFlags |= KEYEVENTF_EXTENDEDKEY;

	SendInput(1, &keyboard_, sizeof(INPUT));
}

WORD KeyboardSynthesizer::getScanCode(BYTE virutalKey)
{
	if (scanCodes_[virutalKey] == 0xffff)
	{
		WORD code = MapVirtualKey(virutalKey, MAPVK_VK_TO_VSC_EX);
		if ((code & 0xff00) == 0 || (code & 0xff00) == 0xe000)
			scanCodes_[virutalKey] = code;
		else
			scanCodes_[virutalKey] = 0;
	}

	return scanCodes_[virutalKey];
}

