#include <tchar.h>
#include <Windows.h>
#include <Shlwapi.h>
#include "constants.h"
#include "MainWindow.hpp"
#include "resource.h"
#include "StringTable.hpp"

TCHAR* INI_FILE_PATH = nullptr;
HBRUSH BACKGROUND_BRUSH = nullptr;

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	UNREFERENCED_PARAMETER(nCmdShow);

	// 2dN͂Ȃ(zbgL[ĝł₱Ȃ)
	HANDLE mutexHandle = CreateMutex(NULL, TRUE, _T("Key sequencer"));
	if (GetLastError() == ERROR_ALREADY_EXISTS)
		return 1;

	StringTable::initialize(hInstance);

	INI_FILE_PATH = new TCHAR[MAX_PATH];

	// st@C̃tpX擾
	if (GetModuleFileName(NULL, INI_FILE_PATH, MAX_PATH) == 0)
	{
		MessageBox(nullptr, StringTable::get(IDS_ERROR_APPLICATION_INITIALIZE), StringTable::get(IDS_ERRORDIALOG_CAPTION), ERROR_DIALOG_TYPE);
		delete [] INI_FILE_PATH;
		StringTable::shutdown();
		return 1;
	}

	// tH_ɓOŊgq.iniɕς
	if (!PathRenameExtension(INI_FILE_PATH, _T(".ini")))
	{
		MessageBox(nullptr, StringTable::get(IDS_ERROR_APPLICATION_INITIALIZE), StringTable::get(IDS_ERRORDIALOG_CAPTION), ERROR_DIALOG_TYPE);
		delete [] INI_FILE_PATH;
		StringTable::shutdown();
		return 1;
	}

	BACKGROUND_BRUSH = CreateSolidBrush(BACKGROUND_COLOR);

	MainWindow mainWindow(hInstance);
	if (mainWindow.initialize())
		mainWindow.run();
	else
		MessageBox(nullptr, StringTable::get(IDS_ERROR_APPLICATION_INITIALIZE), StringTable::get(IDS_ERRORDIALOG_CAPTION), ERROR_DIALOG_TYPE);

	DeleteObject(BACKGROUND_BRUSH);

	delete [] INI_FILE_PATH;

	StringTable::shutdown();

	return 0;
}
